int TOOL_apply_cb(int dialog_id, void *client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
	if(UF_initialize() != 0) return(UF_UI_CB_CONTINUE_DIALOG);

	UF_terminate();
	return(UF_UI_CB_CONTINUE_DIALOG); 
}

int TOOL_constructor_cb(int dialog_id, void *client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
	int irc;
	UF_STYLER_item_value_type_t config_item;
	
	if(UF_initialize() != 0) return(UF_UI_CB_CONTINUE_DIALOG);

	config_item.item_attr = UF_STYLER_SUBITEM_VALUES;
	config_item.indicator = UF_STYLER_STRING_VALUE;
	config_item.item_id = TOOL_LIST_0;
	config_item.count = number_of_tool_ret;
	config_item.value.strings = returned_tool_list;

	irc = UF_STYLER_set_value(dialog_id,&config_item); 
	if(irc) get_error(irc);

	UF_terminate();
	return(UF_UI_CB_CONTINUE_DIALOG); 
}

int TOOL_ok_cb(int dialog_id, void *client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
	if(UF_initialize() != 0) return(UF_UI_CB_CONTINUE_DIALOG);

	UF_terminate();
	return(UF_UI_CB_EXIT_DIALOG);                           
}

int TOOL_cancel_cb(int dialog_id, void *client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
	if(UF_initialize() != 0) return(UF_UI_CB_CONTINUE_DIALOG);

	UF_terminate();
	return(UF_UI_CB_EXIT_DIALOG);                       
}


int TOOL_tool_list_activate(int dialog_id, void *client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
	int irc;
	UF_STYLER_item_value_type_t config_item;

	if(UF_initialize() != 0) return(UF_UI_CB_CONTINUE_DIALOG);

	config_item.item_attr = UF_STYLER_VALUE;
	config_item.item_id = TOOL_LIST_0;
	config_item.indicator = UF_STYLER_INTEGER_VALUE;
	config_item.count = 1;
	irc = UF_STYLER_ask_value(dialog_id, &config_item);
	if(irc) get_error(irc);
	index_tool = config_item.value.integer;

	config_item.item_attr = UF_STYLER_VALUE;
	config_item.item_id = TOOL_MATERIALDES;
	config_item.value.string = material_description[index_tool];
	irc = UF_STYLER_set_value(dialog_id,&config_item); 
	if(irc) get_error(irc);

	config_item.item_attr = UF_STYLER_VALUE;
	config_item.item_id = TOOL_DIAMETER;
	config_item.value.real = tool_diam_array[index_tool];
	irc = UF_STYLER_set_value(dialog_id,&config_item); 
	if(irc) get_error(irc);

	config_item.item_attr = UF_STYLER_VALUE;
	config_item.item_id = TOOL_FLUTELENGTH;
	config_item.value.real = tool_flute_ln_array[index_tool];
	irc = UF_STYLER_set_value(dialog_id,&config_item); 
	if(irc) get_error(irc);

	UF_terminate();
	return(UF_UI_CB_CONTINUE_DIALOG); 
}

int TOOL_tool_list_click(int dialog_id, void *client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
	int irc;
	UF_STYLER_item_value_type_t config_item;

	if(UF_initialize() != 0) return(UF_UI_CB_CONTINUE_DIALOG);
	
	config_item.item_attr = UF_STYLER_VALUE;
	config_item.item_id = TOOL_LIST_0;
	config_item.indicator = UF_STYLER_INTEGER_VALUE;
	config_item.count = 1;
	irc = UF_STYLER_ask_value(dialog_id, &config_item);
	if(irc) get_error(irc);
	index_tool = config_item.value.integer;

	UF_terminate();
	return(UF_UI_CB_CONTINUE_DIALOG); 
}

int TOOL_diameter(int dialog_id, void *client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
	if(UF_initialize() != 0) return(UF_UI_CB_CONTINUE_DIALOG);

	UF_terminate();
	return(UF_UI_CB_CONTINUE_DIALOG); 
}

int TOOL_FluteLength(int dialog_id, void *client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
	if(UF_initialize() != 0) return(UF_UI_CB_CONTINUE_DIALOG);

	UF_terminate();
	return(UF_UI_CB_CONTINUE_DIALOG); 
}

int TOOL_MaterialDes(int dialog_id, void *client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
	if(UF_initialize() != 0) return(UF_UI_CB_CONTINUE_DIALOG);

	UF_terminate ();
	return(UF_UI_CB_CONTINUE_DIALOG); 
}


